var search_data = {"index":{"searchIndex":["attempt","warning","attempttimeout","error","kernel","attempt()","attempt()","configuration()","effective_timeout()","execute_with_auto_timeout()","execute_with_custom_timeout()","execute_with_fallback_timeout()","execute_with_fiber_timeout()","execute_with_process_timeout()","execute_with_thread_timeout()","execute_with_timeout()","fiber_compatible_block?()","fiber_only_timeout()","fiber_thread_hybrid_timeout()","fiber_timeout()","freeze_configuration()","log_final_failure()","log_message()","log_retry_attempt()","new()","timeout()","timeout_enabled?()","validate_increment()","validate_interval()","validate_log()","validate_timeout()","validate_tries()"],"longSearchIndex":["attempt","attempt::warning","attempttimeout","attempttimeout::error","kernel","attempt#attempt()","kernel#attempt()","attempt#configuration()","attempt#effective_timeout()","attempt#execute_with_auto_timeout()","attempt#execute_with_custom_timeout()","attempt#execute_with_fallback_timeout()","attempt#execute_with_fiber_timeout()","attempt#execute_with_process_timeout()","attempt#execute_with_thread_timeout()","attempt#execute_with_timeout()","attempttimeout::fiber_compatible_block?()","attempttimeout::fiber_only_timeout()","attempttimeout::fiber_thread_hybrid_timeout()","attempttimeout::fiber_timeout()","attempt#freeze_configuration()","attempt#log_final_failure()","attempt#log_message()","attempt#log_retry_attempt()","attempt::new()","attempttimeout::timeout()","attempt#timeout_enabled?()","attempt#validate_increment()","attempt#validate_interval()","attempt#validate_log()","attempt#validate_timeout()","attempt#validate_tries()"],"info":[["Attempt","","Attempt.html","","<p>The Attempt class encapsulates methods related to multiple attempts at running the same method before …\n"],["Attempt::Warning","","Attempt/Warning.html","","<p>Warning raised if an attempt fails before the maximum number of tries has been reached.\n"],["AttemptTimeout","","AttemptTimeout.html","","<p>Custom timeout implementation that’s more reliable than Ruby’s Timeout module\n"],["AttemptTimeout::Error","","AttemptTimeout/Error.html","",""],["Kernel","","Kernel.html","","<p>Extend the Kernel module with a simple interface for the Attempt class.\n"],["attempt","Attempt","Attempt.html#method-i-attempt","(&block)","<p>Attempt to perform the operation in the provided block up to <code>tries</code> times, sleeping <code>interval</code> between each …\n"],["attempt","Kernel","Kernel.html#method-i-attempt","(**kwargs, &block)","<p>Attempt to perform the operation in the provided block up to <code>tries</code> times, sleeping <code>interval</code> between each …\n"],["configuration","Attempt","Attempt.html#method-i-configuration","()","<p>Returns a summary of the current configuration\n"],["effective_timeout","Attempt","Attempt.html#method-i-effective_timeout","()","<p>Returns the effective timeout value (handles both boolean and numeric values)\n"],["execute_with_auto_timeout","Attempt","Attempt.html#method-i-execute_with_auto_timeout","(timeout_value, &block)","<p>Automatic timeout strategy selection\n"],["execute_with_custom_timeout","Attempt","Attempt.html#method-i-execute_with_custom_timeout","(timeout_value, &block)","<p>Custom timeout using our AttemptTimeout class\n"],["execute_with_fallback_timeout","Attempt","Attempt.html#method-i-execute_with_fallback_timeout","(timeout_value, &block)","<p>Fallback timeout implementation using multiple strategies\n"],["execute_with_fiber_timeout","Attempt","Attempt.html#method-i-execute_with_fiber_timeout","(timeout_value, &block)","<p>Fiber-based timeout - lightweight alternative\n"],["execute_with_process_timeout","Attempt","Attempt.html#method-i-execute_with_process_timeout","(timeout_value, &block)","<p>Process-based timeout - most reliable for I/O operations\n"],["execute_with_thread_timeout","Attempt","Attempt.html#method-i-execute_with_thread_timeout","(timeout_value, &block)","<p>Improved thread-based timeout\n"],["execute_with_timeout","Attempt","Attempt.html#method-i-execute_with_timeout","(&block)","<p>Execute the block with appropriate timeout mechanism Uses multiple strategies for better reliability …\n"],["fiber_compatible_block?","AttemptTimeout","AttemptTimeout.html#method-c-fiber_compatible_block-3F","(&block)","<p>Simple heuristic to determine if a block is likely to be fiber-compatible (This is a basic implementation …\n"],["fiber_only_timeout","AttemptTimeout","AttemptTimeout.html#method-c-fiber_only_timeout","(seconds, &block)","<p>Pure fiber-based timeout for cooperative code\n"],["fiber_thread_hybrid_timeout","AttemptTimeout","AttemptTimeout.html#method-c-fiber_thread_hybrid_timeout","(seconds, &block)","<p>Hybrid approach: fiber in a thread with timeout\n"],["fiber_timeout","AttemptTimeout","AttemptTimeout.html#method-c-fiber_timeout","(seconds, &block)","<p>Alternative: Fiber-based timeout (lightweight, cooperative) Note: This only works for code that yields …\n"],["freeze_configuration","Attempt","Attempt.html#method-i-freeze_configuration","()",""],["log_final_failure","Attempt","Attempt.html#method-i-log_final_failure","(total_attempts, error)","<p>Log final failure information\n"],["log_message","Attempt","Attempt.html#method-i-log_message","(message)","<p>Helper method to handle logging to various output types\n"],["log_retry_attempt","Attempt","Attempt.html#method-i-log_retry_attempt","(attempt_number, error)","<p>Log retry attempt information\n"],["new","Attempt","Attempt.html#method-c-new","(**options)","<p>Creates and returns a new <code>Attempt</code> object. The supported keyword options are as follows:\n<p>tries     - The …\n"],["timeout","AttemptTimeout","AttemptTimeout.html#method-c-timeout","(seconds, &block)","<p>More reliable timeout using Thread + sleep instead of Timeout.timeout This approach is safer as it doesn’t …\n"],["timeout_enabled?","Attempt","Attempt.html#method-i-timeout_enabled-3F","()","<p>Returns true if this attempt instance has been configured to use timeouts\n"],["validate_increment","Attempt","Attempt.html#method-i-validate_increment","(increment)",""],["validate_interval","Attempt","Attempt.html#method-i-validate_interval","(interval)",""],["validate_log","Attempt","Attempt.html#method-i-validate_log","(log)",""],["validate_timeout","Attempt","Attempt.html#method-i-validate_timeout","(timeout)",""],["validate_tries","Attempt","Attempt.html#method-i-validate_tries","(tries)","<p>Validation methods for better error handling\n"]]}}